Attribute VB_Name = "ModIUnknown"
Option Explicit
'wird von QueryInterface zurckgegeben, falls das Objekt kein Interface hat:
Public Const E_NOINTERFACE As Long = &H80004002

'dies ist der typische VTable der Schnittstelle IUnknown
Public Type TIUnknownVTable
    PQueryInterface As Long
    PAddRef         As Long
    PRelease        As Long
End Type
'auch bekannt als Alias MoveMemory, Alias CopyMemory, Alias cpymem etc.
Public Declare Sub RtlMoveMemory Lib "kernel32" ( _
    ByRef pDst As Any, ByRef pSrc As Any, ByVal bytLength As Long)

'die folgenden drei Funktionsrmpfe kann man so bernehmen, und werden
'in jedem Objekt gebraucht.
Private Function QueryInterface(this As TIUnknownVTable, riid As Long, pvObj As Long) As Long
    'pvObj = 0
    'bei Objekten die kein Interface haben:
    'QueryInterface = E_NOINTERFACE
End Function
Private Function AddRef(this As TIUnknownVTable) As Long
    'hier wird eine Referenz hinzugefgt
End Function
Private Function Release(this As TIUnknownVTable) As Long
    'hier wird eine Referenz abgezogen
End Function

Public Function FncPtr(ByVal pfn As Long) As Long
    FncPtr = pfn
End Function
