Attribute VB_Name = "ModMouseCursor"
Option Explicit

Private mIUVTable As TIUnknownVTable
Private mpVTable  As Long '= VarPtr(mIUVTable)

Public Type TMouseCursor
    pVTable     As Long
    pThisObject As IUnknown
    PrevCursor  As VBRUN.MousePointerConstants
End Type

'das Propertyprefix "New_" soll daran erinnern, da hier ein Objekt erstellt wird !-)
Public Property Let New_MouseCursor(this As TMouseCursor, NewCursor As VBRUN.MousePointerConstants)
    
    If mpVTable = 0 Then
        
        'so jetzt mu man zuerst mal die Funktionspointer ermitteln
        'das wird aber nur ein einzigesmal im gesamten Projekt gemacht!
        With mIUVTable
            .PQueryInterface = FncPtr(AddressOf QueryInterface)
            .PAddRef = FncPtr(AddressOf AddRef)
            .PRelease = FncPtr(AddressOf Release)
        End With
        mpVTable = VarPtr(mIUVTable)
    
    End If
    With this
        
        'den vorherigen MouseCursor in der Variable speichern
        .PrevCursor = Screen.MousePointer
        .pVTable = mpVTable
        Call RtlMoveMemory(.pThisObject, VarPtr(.pVTable), 4)
    
    End With
    
    'hier jetzt den neuen MouseCursor zuweisen
    Screen.MousePointer = NewCursor
    
End Property

'hier jetzt die drei Funktionsrmpfe von ModIUnknown reinkopieren:
'sie werden natrlich noch angepasst

'die folgenden drei Funktionsrmpfe kann man so bernehmen, und werden
'in jedem Objekt gebraucht.
Private Function QueryInterface(this As TMouseCursor, riid As Long, pvObj As Long) As Long
    
    pvObj = 0
    'bei Objekten die kein Interface haben:
    QueryInterface = E_NOINTERFACE
    
End Function

Private Function AddRef(this As TMouseCursor) As Long
    
    'hier wird eine Referenz hinzugefgt
    'im Objekt MouseCursor brauchen wir das aber garnicht
    
End Function

Private Function Release(this As TMouseCursor) As Long
    
    'hier wird eine Referenz abgezogen
    'wird diese Funktion einmalig aufgerufen,
    'dann den alten MouseCursor wiederherstellen
    Screen.MousePointer = this.PrevCursor
    
End Function

